﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Public xui As XUI
	Private Label1 As B4XView
	Private ScrollView1 As B4XView
	Private PrefDialog1 As PreferencesDialog
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

Private Sub B4XPage_Resize(Width As Int, Height As Int)
	If PrefDialog1.IsInitialized And PrefDialog1.Dialog.Visible Then PrefDialog1.Dialog.Resize(Width, Height)
End Sub

'Sub Activity_KeyPress (KeyCode As Int) As Boolean
'	Log(KeyCode)
''	xui.MsgboxAsync($"KeyCode: ${KeyCode}"$, "Info")
'	If KeyCode = KeyCodes.KEYCODE_BACK Then
'		Return B4XPages.Delegate.Activity_KeyPress(KeyCode)
'	End If
'	Select KeyCode
'		Case KeyCodes.KEYCODE_DPAD_LEFT, KeyCodes.KEYCODE_DPAD_RIGHT, KeyCodes.KEYCODE_DPAD_UP, KeyCodes.KEYCODE_DPAD_DOWN
'			
'	End Select
'	B4XPages.GetManager.RaiseEvent(B4XPages.GetManager.GetTopPage, "B4XPage_KeyPress", Array(KeyCode))
'	Return False
'End Sub

Private Sub Button1_Click
	Dim sf As Object = zgShowDialog("Test Dialog", _
	xui.Color_Blue, _
	xui.Color_Magenta, _
	$"This is a sample message in B4XPreferenceDialog.
This message is very long so you can scroll it.
Do you want to close this dialog?"$, _
	"CENTER", _
	18, _
	xui.Color_Yellow, _
	"Yup", _
	xui.Color_Green, _
	"Nah!", _
	xui.Color_Red, _
	"LIGHT", _
	150, _
	True, _
	100)
	Wait For (sf) Complete (result As Boolean)
	Log(result)
End Sub

Public Sub zgShowDialog (Title As String, _
	TitleBackColor As Int, _
	TitleTextColor As Int, _
	Msg As String, _
	msgAlign As String, _
	FontSize As Int, _
	FontColor As Int, _ 
    btnYES As String, _
	btnYES_TextColor As Int, _
	btnNO As String, _
	btnNO_TextColor As Int, _
	Theme As String, _
	DialogHeight As Int, _
	CanScroll As Boolean, _
	Top As Int) As ResumableSub
	If DialogHeight < 150dip Then DialogHeight = 150dip
	If FontSize < 12 Then FontSize = 12
	If btnYES = "" And btnNO = "" Then btnNO = "OK"
	Select msgAlign.ToUpperCase
		Case "LEFT", "CENTER"
			msgAlign = msgAlign.ToUpperCase
		Case Else
			msgAlign = "RIGHT"
	End Select
	If TitleBackColor = 0 Then TitleBackColor = Colors.Red
	If TitleTextColor = 0 Then TitleTextColor = Colors.Yellow
	If Top = 0 Then Top = 100dip

	PrefDialog1.Initialize(Root, "", 300dip, DialogHeight)
	If Theme.ToUpperCase = "LIGHT" Then
		PrefDialog1.Theme = PrefDialog1.THEME_LIGHT
	Else
		PrefDialog1.Theme = PrefDialog1.THEME_DARK
	End If
   
	Dim b4xview1 As B4XView = xui.CreatePanel("")
	b4xview1.SetLayoutAnimated(0, 0, 0, 300dip, 150dip)
	b4xview1.LoadLayout("Custom1")
	
	If Title <> "" Then
		Label1.Text = Title
		Label1.Parent.Color = TitleBackColor
		Label1.TextColor = TitleTextColor
	End If
	
	Dim lbl As Label
	lbl.Initialize("lbl")
	Dim b4xview2 As B4XView = lbl
	b4xview2.SetTextAlignment("CENTER", msgAlign)
	b4xview2.Font = xui.CreateFont(Typeface.DEFAULT_BOLD, FontSize)
	'b4xview2.Color = xui.Color_Transparent
	b4xview2.TextColor = FontColor
	b4xview2.Text = Msg
	
	ScrollView1.ScrollViewContentHeight = DialogHeight + 20dip
	ScrollView1.ScrollViewInnerPanel.Color = xui.Color_Red
	ScrollView1.As(ScrollView).Panel.AddView(lbl, 5dip, 5dip, b4xview1.Width-10dip, b4xview1.Height-10dip)
	Dim sf As Object = PrefDialog1.Dialog.ShowCustom(b4xview1, btnYES, "", btnNO)

	PrefDialog1.Dialog.Base.Color = xui.Color_DarkGray
	PrefDialog1.Dialog.Base.Top = Top
	
	If btnNO <> "" Then
		Dim btnPrefCancel As B4XView = PrefDialog1.Dialog.GetButton(xui.DialogResponse_Cancel)
		btnPrefCancel.Width = btnPrefCancel.Width + 20dip
		btnPrefCancel.Left = btnPrefCancel.Left - 20dip
		btnPrefCancel.TextColor = btnNO_TextColor
		btnPrefCancel.Color = xui.Color_Transparent
	End If
    
	If btnYES <> "" Then
		Dim btnPrefOk As B4XView = PrefDialog1.Dialog.GetButton(xui.DialogResponse_Positive)
		btnPrefOk.Width = btnPrefOk.Width + 20dip
		btnPrefOk.Left = 20dip
		btnPrefOk.TextColor = btnYES_TextColor
		btnPrefOk.Color = xui.Color_Transparent
	End If
	
	If CanScroll = False Then
		Sleep(0)
		Dim extraHeight As Int = 80dip
		ScrollView1.Height = ScrollView1.ScrollViewInnerPanel.Height + extraHeight
		b4xview1.Height = b4xview1.Height + extraHeight
		PrefDialog1.Dialog.Base.Height = PrefDialog1.Dialog.Base.Height + extraHeight
		PrefDialog1.mBase.Height = PrefDialog1.mBase.Height + extraHeight
		If btnNO <> "" Then btnPrefCancel.Top = btnPrefCancel.Top + extraHeight
		If btnYES <> "" Then btnPrefOk.Top = btnPrefOk.Top + extraHeight
	End If
	
	Wait For (sf) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Return True
	End If
	Return False
End Sub